searchNodes=[{"doc":"A MIME Type detection by magic number in Elixir.","ref":"MimeSniff.html","title":"MimeSniff","type":"module"},{"doc":"Sniff a MIME Type from input binary. Options :sniff_len - set how many bytes of data from the head that should be use to determine the MIME Type (default 32). If this value is less than byte_size(data) only data[:sniff_len] will be used; Otherwise, the whole data will be used :custom_signatures - a list of Struct that implemented MimeSniff.Signatures.Signature the given list will be given more priority than the default signature as ordered in Support types section. (see MimeSniff.Signatures.Signature for more information of how to create custom Signature) Examples iex&gt; bin = &lt;&lt; 104 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 115 , 33 &gt;&gt; # hello worlds! iex&gt; MimeSniff . from_binary ( bin ) { :ok , &quot;text/plain&quot; } # for sniff_len and custom_signatures, see examples in from_binary/2","ref":"MimeSniff.html#from_binary/2","title":"MimeSniff.from_binary/2","type":"function"},{"doc":"Sniff a MIME Type from file for the given path. Options same as from_binary/2 Examples iex&gt; MimeSniff . from_file ( &quot;support/fixtures/png_file.png&quot; ) { :ok , &quot;image/png&quot; } # example for sniff_len # only read 32 bytes, if not provided default is 32 bytes iex&gt; MimeSniff . from_file ( &quot;support/fixtures/jpg_file.jpg&quot; , sniff_len : 16 ) { :ok , &quot;image/jpeg&quot; } # example for custom_signatures # MimeSniff.Signatures.ExactSignature struct implemented MimeSniff.Signatures.Signature # utf8_file.txt contain a string &quot;UTF8&quot; iex&gt; alias MimeSniff.Signatures.ExactSignature iex&gt; custom_utf8_sig = % ExactSignature { byte_pattern : &quot;UTF8&quot; , mime_type : &quot;custom/utf8&quot; } iex&gt; custom_utf16_sig = % ExactSignature { byte_pattern : &quot;UTF16&quot; , mime_type : &quot;custom/utf16&quot; } iex&gt; MimeSniff.Sniffing . from_file ( &quot;support/fixtures/utf8_file.txt&quot; ) { :ok , &quot;text/plain&quot; } iex&gt; MimeSniff.Sniffing . from_file ( &quot;support/fixtures/utf8_file.txt&quot; , custom_signatures : [ custom_utf16_sig , custom_utf8_sig ] ) { :ok , &quot;custom/utf8&quot; }","ref":"MimeSniff.html#from_file/2","title":"MimeSniff.from_file/2","type":"function"},{"doc":"","ref":"MimeSniff.html#t:sniff_opt/0","title":"MimeSniff.sniff_opt/0","type":"type"},{"doc":"Guards in this module were implemented as defined in terminlogy","ref":"MimeSniff.Guards.html","title":"MimeSniff.Guards","type":"module"},{"doc":"A gaurd that returns true if term is a binary data byte; otherwise returns false. A binary data byte is a byte in the range 0x00 to 0x08 (NUL to BS), the byte 0x0B (VT), a byte in the range 0x0E to 0x1A (SO to SUB), or a byte in the range 0x1C to 0x1F (FS to US).","ref":"MimeSniff.Guards.html#is_bd/1","title":"MimeSniff.Guards.is_bd/1","type":"macro"},{"doc":"A gaurd that returns true if term is a tag-terminating byte; otherwise returns false. A tag-terminating byte is any one of the following bytes: 0x20 (SP), 0x3E (&quot;&gt;&quot;).","ref":"MimeSniff.Guards.html#is_tt/1","title":"MimeSniff.Guards.is_tt/1","type":"macro"},{"doc":"A gaurd that returns true if term is a whitespace byte; otherwise returns false. A whitespace byte is any one of the following bytes: 0x09 (HT), 0x0A (LF), 0x0C (FF), 0x0D (CR), 0x20 (SP).","ref":"MimeSniff.Guards.html#is_ws/1","title":"MimeSniff.Guards.is_ws/1","type":"macro"},{"doc":"It represent the signature in MIME sniff table that all bytes in Pattern Mask are FF. e.g., For PNG type Byte Pattern : 89 50 4E 47 0D 0A 1A 0A Pattern Mask : FF FF FF FF FF FF FF FF Leading Bytes to Be Ignored : None. Image MIME Type : image/png can be represent as % ExactSignature { byte_pattern : &lt;&lt; 0x89 , 0x50 , 0x4E , 0x47 , 0x0D , 0x0A , 0x1A , 0x0A &gt;&gt; , ignored_ws_leading_bytes : false , mime_type : &quot;image/png&quot; } The ExactSignature struct implement MimeSniff.Signatures.Signature protocol, so it can be use with to do MIME sniffing Examples alias MimeSniff.Signatures.Signature alias MimeSniff.Signatures.ExactSignature png_sig = % ExactSignature { byte_pattern : &lt;&lt; 0x89 , 0x50 , 0x4E , 0x47 , 0x0D , 0x0A , 0x1A , 0x0A &gt;&gt; , ignored_ws_leading_bytes : false , mime_type : &quot;image/png&quot; } # png signature is &quot;An error-checking byte followed by the string &#39;PNG&#39; followed by CR LF SUB LF, the PNG signature&quot; test_data = &lt;&lt; 137 , 80 , 78 , 71 , 13 , 10 , 26 , 10 , 0 , 0 , 0 , 13 &gt;&gt; # data strip from png file Signature . match ( png_sig , test_data ) # {:ok, &quot;image/png&quot;}","ref":"MimeSniff.Signatures.ExactSignature.html","title":"MimeSniff.Signatures.ExactSignature","type":"module"},{"doc":"","ref":"MimeSniff.Signatures.ExactSignature.html#t:t/0","title":"MimeSniff.Signatures.ExactSignature.t/0","type":"type"},{"doc":"It represent the signature in MIME sniff table that all bytes in Pattern Mask are not FF Leading Bytes to Be Ignored is None. e.g., For webp type Byte Pattern : 52 49 46 46 00 00 00 00 57 45 42 50 56 50 Pattern Mask : FF FF FF FF 00 00 00 00 FF FF FF FF FF FF Leading Bytes to Be Ignored : None. Image MIME Type : image/webp can be represent as % MaskedSignature { byte_pattern : &lt;&lt; 0x52 , 0x49 , 0x46 , 0x46 , 0x00 , 0x00 , 0x00 , 0x00 , 0x57 , 0x45 , 0x42 , 0x50 , 0x56 , 0x50 &gt;&gt; , pattern_mask : &lt;&lt; 0xFF , 0xFF , 0xFF , 0xFF , 0x00 , 0x00 , 0x00 , 0x00 , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF &gt;&gt; , mime_type : &quot;image/webp&quot; } The MaskedSignature struct implement MimeSniff.Signatures.Signature protocol, so it can be use with to do MIME sniffing Examples alias MimeSniff.Signatures.Signature alias MimeSniff.Signatures.MaskedSignature webp_sig = % MaskedSignature { byte_pattern : &lt;&lt; 0x52 , 0x49 , 0x46 , 0x46 , 0x00 , 0x00 , 0x00 , 0x00 , 0x57 , 0x45 , 0x42 , 0x50 , 0x56 , 0x50 &gt;&gt; , pattern_mask : &lt;&lt; 0xFF , 0xFF , 0xFF , 0xFF , 0x00 , 0x00 , 0x00 , 0x00 , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF &gt;&gt; , mime_type : &quot;image/webp&quot; } # webp signature is &quot;The string &#39;RIFF&#39; followed by four bytes followed by the string &#39;WEBPVP&#39;&quot; test_data = &quot;RIFFdataWEBPVPdata&quot; Signature . match ( webp_sig , test_data ) # {:ok, &quot;image/webp&quot;}","ref":"MimeSniff.Signatures.MaskedSignature.html","title":"MimeSniff.Signatures.MaskedSignature","type":"module"},{"doc":"","ref":"MimeSniff.Signatures.MaskedSignature.html#t:t/0","title":"MimeSniff.Signatures.MaskedSignature.t/0","type":"type"},{"doc":"This protocol defines the API for Struct to be implemented in order to use with matching signature function. There are some out-of-the-box predefine signature such as MimeSniff.Signatures.ExactSignature and MimeSniff.Signatures.MaskedSignature . Please visit them for more infomation and examples.","ref":"MimeSniff.Signatures.Signature.html","title":"MimeSniff.Signatures.Signature","type":"protocol"},{"doc":"Perform the matching with binary data by matching algorithm define in signature.","ref":"MimeSniff.Signatures.Signature.html#match/2","title":"MimeSniff.Signatures.Signature.match/2","type":"function"},{"doc":"","ref":"MimeSniff.Signatures.Signature.html#t:t/0","title":"MimeSniff.Signatures.Signature.t/0","type":"type"},{"doc":"A MIME Type detection by magic number in Elixir. MimeSniff implements the MIME Sniffing Standard which detect MIME Type from few bytes sequence at the beginning of a file or binary input. This work is faster than calling System.cmd(&quot;file&quot;, [&quot;--mime-type&quot;, file_path] by about 50 times and consume memory 8 times less (see benchmark ).","ref":"readme.html","title":"mime_sniff","type":"extras"},{"doc":"The package can be installed by adding mime_sniff to your list of dependencies in mix.exs : def deps do [ { :mime_sniff , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"mime_sniff - Installation","type":"extras"},{"doc":"iex&gt; MimeSniff . from_file ( &quot;path/to/png_file.png&quot; ) { :ok , &quot;image/png&quot; } iex&gt; MimeSniff . from_binary ( &quot; &lt;h1&gt;Hello, World!&lt;h1/&gt; &quot; ) { :ok , &quot;text/html&quot; } # only read 16 bytes, if not provided default is 32 bytes iex&gt; MimeSniff . from_file ( &quot;path/to/jpg_file.jpg&quot; , sniff_len : 16 ) { :ok , &quot;image/jpeg&quot; }","ref":"readme.html#example","title":"mime_sniff - Example","type":"extras"},{"doc":"This library support most of the MIME Type defined in MIME Sniffing Standard . See Support types for the full list and minimum number of bytes need to perform the sniffing.","ref":"readme.html#support-types","title":"mime_sniff - Support types","type":"extras"},{"doc":"The benchmark result shows that MimeSniff, compared to System.cmd(&quot;file&quot;, [&quot;--mime-type&quot;, file_path]) , is about 50 times faster and consume memory 8 times less with one file and more than 100 times faster with 10,000 files. Full result can be found in benchmark result . or you can run it yourself by executing mix bench . This command will execute benchmark.exs file.","ref":"readme.html#benchmark","title":"mime_sniff - Benchmark","type":"extras"},{"doc":"MimeSniff is released under the MIT License - see the LICENSE file. This work is an implemented from MIME Sniffing Standard that was licensed under Creative Commons Attribution 4.0 International Public License","ref":"readme.html#license","title":"mime_sniff - License","type":"extras"},{"doc":"The tables below show the support MIME Type and minimum number of bytes need to perform. If the length of data that is provided to the function is less than the minimum, the program will return unmatch immediately.","ref":"support_types.html","title":"Support types","type":"extras"},{"doc":"MIME Type Minimum number of bytes need to perform Note text/html 15 text/xml 5 application/pdf 5 application/postscript 11 text/plain 4 UTF-16BE BOM, UTF-16LE BOM, and UTF-8 BOM text file.","ref":"support_types.html#a-html-xml-pdf-postscript-or-utf-text-type-more-info","title":"Support types - A html, xml, pdf, postscript or UTF text type (more info)","type":"extras"},{"doc":"MIME Type Minimum number of bytes need to perform Note x-icon 4 x-icon 4 image/bmp 2 image/gif 6 image/gif 6 image/webp 14 image/png 8 image/jpeg 3","ref":"support_types.html#an-image-type-more-info","title":"Support types - An image type (more info)","type":"extras"},{"doc":"Currently, this application does not support sniffing A MP3 without id3 type MIME Type Minimum number of bytes need to perform Note audio/aiff 12 audio/mpeg 3 application/ogg 5 audio/midi 8 video/avi 12 audio/wave 12 video/mp4 &gt;12 how the algorithm work for mp4 *video/webm *4 only check first four bytes see Matching a WebM type .","ref":"support_types.html#an-audio-or-video-type-more-info","title":"Support types - An audio or video type (more info)","type":"extras"},{"doc":"MIME Type Minimum number of bytes need to perform Note application/vnd.ms-fontobject 36 font/ttf 4 font/otf 4 font/collection 4 font/woff 4 font/woff2 4","ref":"support_types.html#a-font-type-more-info","title":"Support types - A font type (more info)","type":"extras"},{"doc":"MIME Type Minimum number of bytes need to perform Note application/x-gzip 3 application/zip 4 application/x-rar-compressed 7","ref":"support_types.html#an-archive-type-more-info","title":"Support types - An archive type (more info)","type":"extras"},{"doc":"MIME Type Minimum number of bytes need to perform Note text/plain 0 if content contains no binary data bytes application/octet-stream 1 if not match anything else","ref":"support_types.html#other","title":"Support types - Other","type":"extras"},{"doc":"","ref":"license.html","title":"MIT License","type":"extras"},{"doc":"Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html#copyright-c-2022-chaiyatad-chanasuppakul","title":"MIT License - Copyright (c) 2022 Chaiyatad Chanasuppakul","type":"extras"}]